## lizardfs 3.11.2+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR
    "In-source builds are disabled for this project. This is for your "
    "safety. To build the project, please create a build tree in "
    "a separate directory, for example:\n"
    "     mkdir ${CMAKE_SOURCE_DIR}/build\n"
    "     cd ${CMAKE_SOURCE_DIR}/build\n"
    "     cmake ..\n"
    "Before doing that you may need to clean up after this try by removing "
    "CMakeCache.txt file and CMakeFiles/ directory.\n"
    "If you REALLY need an in-source build, remove this check from "
    "${CMAKE_CURRENT_LIST_FILE} and try again."
  )
endif()

set(DEFAULT_USER  "mfs" CACHE STRING "Default user to run daemons as")
set(DEFAULT_GROUP "mfs" CACHE STRING "Default group to run daemons as")
set(LIZARDFS_BLOCKS_IN_CHUNK 1024 CACHE INT "Number of blocks in one chunk")
set(LIZARDFS_BLOCK_SIZE 65536 CACHE INT "Number of bytes in one block")
option(ENABLE_WERROR        "Enable treating compilation warnings as errors"          OFF)
option(ENABLE_LIGHTMFS      "Enable light version of LizardFS"                        OFF)
option(ENABLE_DEBIAN_PATHS  "Enable Debian-style install paths"                       OFF)
option(ENABLE_UTILS         "Enable building additional binaries used e.g. in tests"  OFF)
option(ENABLE_TESTS         "Enable building unit and functional tests"               OFF)
option(ENABLE_DOCS          "Enable building the documentation"                       ON)
option(ENABLE_EXIT_ON_USR1  "Enable handler for SIGUSR1 which calls exit()"           OFF)
option(THROW_INSTEAD_OF_ABORT   "Throw std::exception instead of calling abort"       OFF)
option(ENABLE_DEBUG_LOG     "Enable prefix based debug logs"                          OFF)
option(ENABLE_VERBOSE_ASCIIDOC  "Enable verbose output of asciidoc"                   OFF)
option(ENABLE_TCMALLOC      "Enable use of tcmalloc-minimal library"                  OFF)
option(ENABLE_POLONAISE     "Enable polonaise"                                        ON)
option(ENABLE_OFFICIAL_BUILD "Make the build official"                                OFF)
# end of LizardFS options
option(ENABLE_TRACES        "Enable traces"                                           OFF)
option(ENABLE_CRC           "Enable checksums"                                        ON)
option(ENABLE_REQUEST_LOG   "Enable logging request times"                            OFF)
option(USE_LEGACY_READ_MESSAGES "Enable sending old type of messages by mount"        OFF)

message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "DEFAULT_USER: ${DEFAULT_USER}")
message(STATUS "DEFAULT_GROUP: ${DEFAULT_GROUP}")
message(STATUS "LIZARDFS_BLOCKS_IN_CHUNK: ${LIZARDFS_BLOCKS_IN_CHUNK}")
message(STATUS "LIZARDFS_BLOCK_SIZE: ${LIZARDFS_BLOCK_SIZE}")
message(STATUS "ENABLE_WERROR: ${ENABLE_WERROR}")
message(STATUS "ENABLE_LIGHTMFS: ${ENABLE_LIGHTMFS}")
message(STATUS "ENABLE_DEBIAN_PATHS: ${ENABLE_DEBIAN_PATHS}")
message(STATUS "ENABLE_UTILS: ${ENABLE_UTILS}")
message(STATUS "ENABLE_TESTS: ${ENABLE_TESTS}")
message(STATUS "ENABLE_DOCS: ${ENABLE_DOCS}")
message(STATUS "ENABLE_EXIT_ON_USR1: ${ENABLE_EXIT_ON_USR1}")
message(STATUS "THROW_INSTEAD_OF_ABORT: ${THROW_INSTEAD_OF_ABORT}")
message(STATUS "ENABLE_DEBUG_LOG: ${ENABLE_DEBUG_LOG}")
message(STATUS "ENABLE_VERBOSE_ASCIIDOC: ${ENABLE_VERBOSE_ASCIIDOC}")
message(STATUS "ENABLE_TCMALLOC: ${ENABLE_TCMALLOC}")
message(STATUS "ENABLE_POLONAISE: ${ENABLE_POLONAISE}")
message(STATUS "ENABLE_OFFICIAL_BUILD: ${ENABLE_OFFICIAL_BUILD}")
# end of LizardFS options values
message(STATUS "ENABLE_TRACES: ${ENABLE_TRACES}")
message(STATUS "ENABLE_CRC: ${ENABLE_CRC}")
message(STATUS "ENABLE_REQUEST_LOG: ${ENABLE_REQUEST_LOG}")
message(STATUS "USE_LEGACY_READ_MESSAGES: ${USE_LEGACY_READ_MESSAGES}")

execute_process(COMMAND "git" "rev-parse" "HEAD"
  OUTPUT_VARIABLE GIT_SHA1 RESULT_VARIABLE GIT_SHA1_RETURN_VALUE
  OUTPUT_STRIP_TRAILING_WHITESPACE)

if(NOT ENABLE_OFFICIAL_BUILD AND GIT_SHA1_RETURN_VALUE EQUAL 0)
	set(PACKAGE_VERSION_SUFFIX "-devel-${GIT_SHA1}")
elseif(NOT ENABLE_OFFICIAL_BUILD)
	set(PACKAGE_VERSION_SUFFIX "-devel")
else()
	set(PACKAGE_VERSION_SUFFIX "")
endif()

project(lizardfs)
set(PACKAGE_VERSION_MAJOR 3)
set(PACKAGE_VERSION_MINOR 11)
set(PACKAGE_VERSION_MICRO 2)
set(PACKAGE_VERSION
    "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_MICRO}${PACKAGE_VERSION_SUFFIX}")

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug)
endif()

set(CXX_STD c++0x)
if(CMAKE_CXX_COMPILER_ID MATCHES ".*Clang.*")
  set(CXX_STD c++11)
endif()
if(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64" )
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -m64")
endif()
if(MINGW)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wformat=0")
endif()
string(REPLACE "-DNDEBUG" "" CMAKE_CXX_FLAGS_RELWITHDEBINFO ${CMAKE_CXX_FLAGS_RELWITHDEBINFO})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pipe -std=${CXX_STD} -pthread -Wall -Wextra -fwrapv")
set(CMAKE_CXX_FLAGS_DEBUG "-O0 -g")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -DNDEBUG -g")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -O2 -ftree-vectorize -g -fno-omit-frame-pointer")
set(CMAKE_CXX_FLAGS_COVERAGE "-O0 -g --coverage")
set(CMAKE_CXX_FLAGS_CLANG_ANALYZE "--analyze -Xanalyzer -analyzer-output=text")
set(CMAKE_CXX_FLAGS_CLANG_SANITIZE_THREAD "-g -O0 -fsanitize=thread")

set(CMAKE_CXX_FLAGS_CXXDEBUG "-O0 -g -D_GLIBCXX_DEBUG")

add_definitions(-D_LARGEFILE_SOURCE)
add_definitions(-D_FILE_OFFSET_BITS=64)
add_definitions(-DLIZARDFS_HAVE_CONFIG_H)
add_definitions(-D__STDC_LIMIT_MACROS)
add_definitions(-D__STDC_CONSTANT_MACROS)
add_definitions(-D__STDC_FORMAT_MACROS)
if(MINGW)
  add_definitions(-DWINVER=0x0602)
  add_definitions(-D_WIN32_WINNT=0x0602)
  add_definitions(-DFD_SETSIZE=1024)
endif()

# All the environment tests (libs, includes, etc.) live here:
include(EnvTests)
include(Libraries)
include(GNUInstallDirs)
include(CollectSources)
include(CreateUnitTest)

# Disable -pedantic for old gcc because of unfounded
# "no comma at end of enumerator list" warning during crcutil compilation
execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE COMPILER_VERSION)
if(ENABLE_WERROR AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND COMPILER_VERSION VERSION_LESS 4.7)
  message(STATUS "Flag '-pedantic' disabled for GCC < 4.7")
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic")
endif()

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qunused-arguments")
endif()

if(CXX_HAS_WNOGNU)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-gnu")
endif()

if(ENABLE_WERROR)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

if(ENABLE_TESTS AND NOT THROW_INSTEAD_OF_ABORT)
  message(STATUS "Tests require THROW_INSTEAD_OF_ABORT to be set to YES, changing passed value:")
  set(THROW_INSTEAD_OF_ABORT YES)
  message(STATUS "THROW_INSTEAD_OF_ABORT: ${THROW_INSTEAD_OF_ABORT}")
endif()

if(ENABLE_DEBIAN_PATHS)
  if (NOT CMAKE_INSTALL_PREFIX STREQUAL "/")
    message(WARNING "Debian paths enabled, but CMAKE_INSTALL_PREFIX is different than /")
  endif()
  set(BIN_SUBDIR   "usr/bin")
  set(SBIN_SUBDIR  "usr/sbin")
  set(LIB_SUBDIR   "usr/lib")
  set(ETC_SUBDIR   "etc/mfs")
  set(RUN_SUBDIR   "var/run/mfs")
  set(DATA_SUBDIR  "var/lib/mfs")
  set(MAN_SUBDIR   "usr/share/man")
  set(CGI_SUBDIR   "usr/share/mfscgi")
else()
  set(BIN_SUBDIR   "bin")
  set(SBIN_SUBDIR  "sbin")
  set(LIB_SUBDIR   "lib")
  set(ETC_SUBDIR   "etc/mfs")
  set(RUN_SUBDIR   "var/run/mfs")
  set(DATA_SUBDIR  "var/lib/mfs")
  set(MAN_SUBDIR   "share/man")
  set(CGI_SUBDIR   "share/mfscgi")
endif()

string(REGEX REPLACE "/$" "" INSTALL_PREFIX_NO_SLASH ${CMAKE_INSTALL_PREFIX})
set(BIN_PATH   ${INSTALL_PREFIX_NO_SLASH}/${BIN_SUBDIR})
set(SBIN_PATH  ${INSTALL_PREFIX_NO_SLASH}/${SBIN_SUBDIR})
set(LIB_PATH   ${INSTALL_PREFIX_NO_SLASH}/${LIB_SUBDIR})
set(ETC_PATH   ${INSTALL_PREFIX_NO_SLASH}/${ETC_SUBDIR})
set(RUN_PATH   ${INSTALL_PREFIX_NO_SLASH}/${RUN_SUBDIR})
set(DATA_PATH  ${INSTALL_PREFIX_NO_SLASH}/${DATA_SUBDIR})
set(MAN_PATH   ${INSTALL_PREFIX_NO_SLASH}/${MAN_SUBDIR})
set(CGI_PATH   ${INSTALL_PREFIX_NO_SLASH}/${CGI_SUBDIR})

if(ENABLE_LIGHTMFS)
  set(PROTO_BASE 65536)
  set(LIGHT_MFS 1)
else()
  set(PROTO_BASE 0)
  set(LIGHT_MFS 0)
endif()

if(ENABLE_UTILS)
  set(BUILD_UTILS ON)
endif()

if(ENABLE_TESTS)
  set(BUILD_TESTS ON)
  set(BUILD_UTILS ON)
  set(LIZARDFS_ENABLE_DEBUG_LOG ON)
endif()

if(ENABLE_DEBUG_LOG)
  set(LIZARDFS_ENABLE_DEBUG_LOG ON)
endif()

if(NOT Boost_INCLUDE_DIRS)
  message(FATAL_ERROR "Boost headers are required")
endif()

if(ENABLE_TRACES)
  add_definitions(-DENABLE_TRACES)
endif()

if(ENABLE_REQUEST_LOG)
  if(NOT Boost_IOSTREAMS_FOUND)
    message(FATAL_ERROR "Boost iostreams is required if request time logging is enabled")
  endif()
  set(ADDITIONAL_LIBS ${Boost_IOSTREAMS_LIBRARY})
  add_definitions(-DENABLE_REQUEST_LOG)
endif()

set(CHARTS_CSV_CHARTID_BASE 90000)

if(THROW_INSTEAD_OF_ABORT)
  add_definitions(-DTHROW_INSTEAD_OF_ABORT)
endif()

if(USE_LEGACY_READ_MESSAGES)
  add_definitions(-DUSE_LEGACY_READ_MESSAGES)
endif()

if(ENABLE_CRC)
  message(STATUS "CRC checksums enabled")
  add_definitions(-DENABLE_CRC)
else()
  message(STATUS "CRC checksums disabled")
endif()

set(CHARTS_CSV_CHARTID_BASE 90000)

# Create config.h file
configure_file(config.h.in config.h)
include_directories(${CMAKE_BINARY_DIR}) # Here we have generated config.h

# main.cc shared by some LizardFS applications
set(MAIN_SRC ${CMAKE_SOURCE_DIR}/src/main/main.cc)

if(ZLIB_FOUND)
  include_directories(${ZLIB_INCLUDE_DIRS})
endif()
include_directories(src) # Allow paths relative to src, eg. #include common/crc.h
link_directories( ${LINK_DIRECTORIES} ${FUSE_LIBRARY_DIR} )
add_subdirectory(external)
add_subdirectory(src/admin)
add_subdirectory(src/common)
add_subdirectory(src/protocol)
add_subdirectory(src/mount)

if(ENABLE_POLONAISE)
  add_subdirectory(src/mount/polonaise)
endif()

if(NOT MINGW)
  if(BUILD_DEVTOOLS)
    add_subdirectory(src/devtools)
  endif()
  add_subdirectory(src/chunkserver)
  add_subdirectory(src/master)
  add_subdirectory(src/metadump)
  add_subdirectory(src/metalogger)
  add_subdirectory(src/metarestore)
  add_subdirectory(src/tools)
  if (FUSE_LIBRARY)
    add_subdirectory(src/mount/fuse)
  endif()
  add_subdirectory(src/data)
  add_subdirectory(src/cgi)
  if(BUILD_UTILS)
    add_subdirectory(utils)
  endif()
  if(BUILD_TESTS)
    add_subdirectory(src/unittests)
    add_subdirectory(tests)
  endif()
  if(ENABLE_DOCS)
    add_subdirectory(doc)
  endif()
endif()

=== debian/changelog ===
lizardfs (3.11.2+dfsg-2) unstable; urgency=medium

  * New patch to fix empty "Filesystem check info".
  * cgiserv/Depends += "lsb-base".
  * Update copyright format URL to HTTPS.
  * Debhelper & compat to version 10.
  * Standards-Version: 4.0.0.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 09 Jul 2017 13:40:01 +1000

lizardfs (3.11.2+dfsg-1) experimental; urgency=medium

  * New upstream release [June 2017].

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 17 Jun 2017 15:15:27 +1000

lizardfs (3.11.0+dfsg-4) experimental; urgency=medium

  * New upstream patch to fix segfault in client.

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 06 Jun 2017 20:52:04 +1000

lizardfs (3.11.0+dfsg-3) experimental; urgency=medium

  * New upstream patch to fix segfault in master.

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 24 May 2017 07:37:10 +1000

lizardfs (3.11.0+dfsg-2) experimental; urgency=medium

  * New upstream patch to fix high CPU usage in master.

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 22 May 2017 00:23:38 +1000

lizardfs (3.11.0+dfsg-1) experimental; urgency=medium

  * New upstream release [May 2017].

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 14 May 2017 23:48:11 +1000

lizardfs (3.10.4+dfsg-4) unstable; urgency=high

  * New backported "526_gcc6.2.patch" to fix serious run-time regression.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 11 Mar 2017 14:35:50 +1100

lizardfs (3.10.4+dfsg-3) unstable; urgency=medium

  * Build-Depends: libgtest-dev --> googletest (Closes: #844893).

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 20 Nov 2016 01:00:13 +1100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

## fix FTBFS@ppc64: https://github.com/lizardfs/lizardfs/issues/249
ifneq (,$(filter $(DEB_HOST_ARCH),mips mipsel powerpc powerpcspe sparc hppa m68k sh4))
DEB_LDFLAGS_MAINT_APPEND = -latomic
endif

# minimise needless linking
export DEB_LDFLAGS_MAINT_APPEND += -Wl,--as-needed

export XSLTPROCFLAGS=--nonet

%:
	dh $@ --buildsystem=cmake --builddirectory=build --parallel --with systemd,python2,bash-completion

override_dh_auto_clean:
	$(RM) -rv external/gtest
	dh_auto_clean

override_dh_auto_configure:
	## copy gtest sources
	mkdir -p external/gtest
	cp -Rv /usr/src/googletest/googletest/* external/gtest/
	dh_auto_configure --               \
               -DCMAKE_BUILD_TYPE=Release   \
               -DCMAKE_INSTALL_PREFIX="/"   \
               -DCMAKE_VERBOSE_MAKEFILE=ON  \
               -DENABLE_VERBOSE_ASCIIDOC=ON \
               -DENABLE_DEBIAN_PATHS=YES    \
               -DENABLE_TCMALLOC=NO         \
               -DENABLE_UTILS=YES           \
               -DENABLE_TESTS=YES

override_dh_auto_install:
	dh_auto_install
	## rename config files
	for i in debian/tmp/etc/lizardfs/*.cfg.dist; do \
	    mv -n -v "$$i" "$${i%%.dist}"          \
	;done

override_dh_python2:
	dh_python2
	dh_python2 /usr/share/mfscgi

override_dh_gencontrol:
	dh_gencontrol -- -Vmy:Built-Using="$(foreach pkg,googletest,$(word 2,$(shell dpkg --status $(pkg) | grep ^Package)) (=$(word 2,$(shell dpkg --status $(pkg) | grep Version))),)"

override_dh_compress:
	## See #781131
	dh_compress --exclude="examples/mfsexports.cfg" --exclude="examples/mfsmaster.cfg"

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_installinit:
	dh_installinit --no-start

override_dh_systemd_start:
	dh_systemd_start --no-start

override_dh_systemd_enable:
	dh_systemd_enable --no-enable

override_dh_strip:
	dh_strip --dbgsym-migration='lizardfs-dbg (<< 3.10.0~)'

## http://wiki.debian.org/onlyjob/get-orig-source
.PHONY: get-orig-source
PKD   = $(abspath $(dir $(MAKEFILE_LIST)))
PKG   = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
VER  ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog -SVersion | perl -ne 'print $$1 if m{^(?:\d+:)?(\d.*)(?:\-\d+.*)};')
REV   = $(shell sh -c 'printf "$${1\#\#*\.0\.}"' -- "$(VER)")

get-orig-source: $(PKG)_$(VER).orig.tar.xz $(info I: $(PKG)_$(VER))
	@

UURL = https://github.com/lizardfs/lizardfs
$(PKG)_$(VER).orig.tar.xz:
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
	@echo "# Downloading..."
	wget --tries=3 --timeout=40 --read-timeout=40 --continue -O $@ \
          $(UURL)/archive/$(REV).tar.gz \
        || uscan --noconf --verbose --rename --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-current-version $(PKD)
	mk-origtargz --repack --repack-suffix "" --compression xz --directory . $@

## lizardfs 3.11.3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -79,7 +79,7 @@
 project(lizardfs)
 set(PACKAGE_VERSION_MAJOR 3)
 set(PACKAGE_VERSION_MINOR 11)
-set(PACKAGE_VERSION_MICRO 2)
+set(PACKAGE_VERSION_MICRO 3)
 set(PACKAGE_VERSION
     "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_MICRO}${PACKAGE_VERSION_SUFFIX}")

=== src/common/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

collect_sources(COMMON)

if(MINGW)
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/lockfile.cc")
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/metadata.cc")
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/setup.cc")
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/loop_watchdog.cc")
endif()

if(ISAL_LIBRARY)
  list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/galois_field_isal.cc")
  list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/galois_field_encode.cc")
endif()

add_library(mfscommon ${COMMON_SOURCES})
if (HAVE_CRCUTIL)
  # Use crcutil Library
  include_directories(${CRCUTIL_INCLUDE_DIRS})
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CRCUTIL_CXX_FLAGS}")
  target_link_libraries(mfscommon ${CRCUTIL_LIBRARIES})
endif()
if (ZLIB_FOUND)
  target_link_libraries(mfscommon ${ZLIB_LIBRARIES})
endif()
if (RT_LIBRARY)
  target_link_libraries(mfscommon ${RT_LIBRARY})
endif()
if(TCMALLOC_LIBRARY)
  target_link_libraries(mfscommon ${TCMALLOC_LIBRARY})
endif()
if(SOCKET_FOUND)
  target_link_libraries(mfscommon ${SOCKET_LIBRARIES})
endif()
if(ISAL_LIBRARY)
  target_link_libraries(mfscommon ${ISAL_LIBRARY})
endif()

create_unittest(mfscommon ${COMMON_TESTS})
link_unittest(mfscommon mfscommon master)

=== src/metarestore/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR} ../master)
add_definitions(-DMETARESTORE)
add_definitions(-DAPPNAME=mfsmetarestore)

collect_sources(METARESTORE)

file(GLOB METARESTORE_MASTER_SOURCES ../master/filesystem*.cc)

if(DB_FOUND)
  file(GLOB METARESTORE_HSTRING_SOURCES ../master/hstring_*storage.cc)
else()
  file(GLOB METARESTORE_HSTRING_SOURCES ../master/hstring_memstorage.cc)
endif()

add_library(metarestore ${METARESTORE_SOURCES} ${METARESTORE_MASTER_SOURCES} ${METARESTORE_HSTRING_SOURCES}
  ../master/chunks.cc ../master/quota_database.cc ../master/chunk_goal_counters.cc ../master/restore.cc
  ../master/locks.cc ../master/task_manager.cc ../master/snapshot_task.cc ../master/setgoal_task.cc
  ../master/settrashtime_task.cc)

target_link_libraries(metarestore mfscommon)
if(JUDY_LIBRARY)
  target_link_libraries(metarestore ${JUDY_LIBRARY})
endif()

create_unittest(metarestore ${METARESTORE_TESTS})

add_executable(mfsmetarestore ${METARESTORE_MAIN})
target_link_libraries(mfsmetarestore metarestore mfscommon ${PAM_LIBRARIES})
install(TARGETS mfsmetarestore RUNTIME DESTINATION ${SBIN_SUBDIR})

=== src/mount/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

collect_sources(MOUNT)

add_library(mount ${MOUNT_SOURCES})
target_link_libraries(mount mfscommon ${ADDITIONAL_LIBS} ${Boost_THREAD_LIBRARY})

create_unittest(mount ${MOUNT_TESTS})
link_unittest(mount mount mfscommon)

install(PROGRAMS mfssnapshot DESTINATION ${BIN_SUBDIR})

=== src/protocol/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

collect_sources(PROTOCOL)

add_library(lzfsprotocol ${PROTOCOL_SOURCES})

# if (ZLIB_FOUND)
#   target_link_libraries(mfscommon ${ZLIB_LIBRARIES})
# endif()
# if (RT_LIBRARY)
#   target_link_libraries(mfscommon ${RT_LIBRARY})
# endif()
# if(TCMALLOC_LIBRARY)
#   target_link_libraries(mfscommon ${TCMALLOC_LIBRARY})
# endif()
# if(SOCKET_FOUND)
#   target_link_libraries(mfscommon ${SOCKET_LIBRARIES})
# endif()
create_unittest(lzfsprotocol ${PROTOCOL_TESTS})
link_unittest(lzfsprotocol mfscommon)

=== debian/changelog ===
lizardfs (3.11.3+dfsg-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 29 Jan 2018 06:26:51 +1100

lizardfs (3.11.3+dfsg-2) unstable; urgency=medium

  * Build on armel with "-latomic" (Closes: #872822).
    Thanks, Adrian Bunk.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 10 Sep 2017 19:17:40 +1000

lizardfs (3.11.3+dfsg-1) unstable; urgency=medium

  * New upstream release [July 2017].

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 20 Aug 2017 11:27:37 +1000

=== debian/control ===
Source: lizardfs
Section: admin
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Build-Depends: debhelper (>= 10), dh-python, dh-systemd, bash-completion
              ,python-all
              ,cmake
              ,asciidoc
                  ,libxml2-utils
                  ,docbook-xml
                  ,docbook-xsl
                  ,xsltproc
              ,pkg-config
# libcrcutil is for little-endian architectures only.
              ,libcrcutil-dev [!hppa !m68k !mips !powerpc !powerpcspe !ppc64 !s390 !s390x !sparc !sparc64]
              ,libfuse-dev (>= 2.9.0)
              ,libdb-dev
#_beware:     ,libgoogle-perftools-dev
              ,googletest
              ,libisal-dev [amd64 kfreebsd-amd64]
              ,libjudy-dev
              ,libpam-dev
              ,libsystemd-dev [!kfreebsd-any]
#             ,libthrift-dev
              ,zlib1g-dev
# -DENABLE_TESTS=YES requirements:
             ,libboost-all-dev
Standards-Version: 4.0.0
X-Python-Version: >= 2.7 << 3.0
Homepage: http://lizardfs.org/
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/lizardfs.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/lizardfs.git

Package: lizardfs-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
        ,adduser
Description: LizardFS - common files
 Files and services common for all LizardFS daemons.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-master
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base
        ,lizardfs-common (>= ${source:Version})
Description: LizardFS - master server
 LizardFS master (metadata) server.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-metalogger
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base
        ,lizardfs-common (>= ${source:Version})
Description: LizardFS - metalogger server
 LizardFS metadata replication (backup) server.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-chunkserver
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base
        ,lizardfs-common (>= ${source:Version})
Description: LizardFS - data server
 The LizardFS data server.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-client
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: fuse
Description: LizardFS - client tools and mount utility
 LizardFS FUSE mount utility "mfsmount" and client tool "mfstools".
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-adm
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: LizardFS - administration tools
 LizardFS administration tool: lizardfs-probe
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-cgi
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}
        ,python
Description: LizardFS - CGI monitor
 CGI application to monitor LizardFS through master/metadata server.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-cgiserv
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base
        ,lizardfs-cgi
        ,lizardfs-common (>= ${source:Version})
        ,${python:Depends}
Description: simple CGI-capable HTTP server to run LizardFS CGI monitor
 Simple standalone CGI-capable HTTP server to run LizardFS CGI Monitor.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

#Package: lizardfs-tests
#Built-Using: ${my:Built-Using}
#Architecture: any
#Depends: ${shlibs:Depends}, ${misc:Depends}
#        ,lizardfs-common (>= ${source:Version})
#        ,lizardfs-chunkserver (>= ${source:Version})
#        ,lizardfs-master (>= ${source:Version})
#        ,lizardfs-client (>= ${source:Version})
#        ,lizardfs-adm (>= ${source:Version})
#        ,attr
#        ,dbench
#        ,fuse
#        ,netcat-openbsd
#        ,socat
#        ,sudo
#        ,valgrind
#Description: LizardFS - tests suite
# The LizardFS test suite.
# .
# LizardFS is a reliable, scalable and efficient distributed file system. It
# spreads data over a number of physical servers, making it visible to an
# end user as a single file system.
# .
# Functions such as data replication, checksums, instant snapshots and easy
# connection of additional servers make LizardFS a perfect solution for
# users who need fault-proof storage ready for future expansion.
# LizardFS features include:
#  * High availbility.
#  * Quotas.
#  * POSIX Access Control Lists and POSIX Extended Attributes.
#  * I/O bandwidth limiting.
# .
# LizardFS can be used whenever one needs to store large quantities of data
# in a secure way and process them swiftly.
# LizardFS is a fork of MooseFS.

=== debian/watch ===
# uscan(1) configuration file.
version=3

opts=\
repacksuffix=+dfsg,\
dversionmangle=s{\+dfsg\d*}{},\
uversionmangle=s{\-(\d+|rc)\Z}{~$1},\
 https://github.com/lizardfs/lizardfs/releases \
 .*/archive/v?\.?(\d[-rc\d\.]+)\.tar\.gz

## lizardfs 3.12.0%2Bdfsg

=== tests/CMakeLists.txt ===
include_directories(${GTEST_INCLUDE_DIRS})

# Create automatically generated list of test cases
add_custom_target(list_of_test_cases
  COMMAND ls ${CMAKE_CURRENT_SOURCE_DIR}/test_suites
    | xargs -IXXX echo "class XXX : public BashTestingSuite {};"
    > test_suites.h.tmp
  COMMAND ${CMAKE_COMMAND} -E copy_if_different test_suites.h.tmp test_suites.h

  COMMAND find ${CMAKE_CURRENT_SOURCE_DIR}/test_suites/ -name test_*.sh
    | sed -e "s/[.]sh$//"
    | awk -F/ "{print $(NF-1) \",\" $NF}"
    | xargs -IXXX echo "add_test_case(XXX)"
    > test_cases.h.tmp
  COMMAND ${CMAKE_COMMAND} -E copy_if_different test_cases.h.tmp test_cases.h

  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  VERBATIM)
set_source_files_properties(lizardfs-tests.cc PROPERTIES
  OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/test_cases.h
  OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/test_suites.h)

# Create constants.sh file
configure_file(set_lizardfs_constants.sh.in set_lizardfs_constants.sh @ONLY)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/set_lizardfs_constants.sh DESTINATION ${BIN_SUBDIR})

# Build executable running all the test cases
include_directories(${CMAKE_CURRENT_BINARY_DIR}) # test_cases.h is located here
add_definitions(-DTEST_DATA_PATH=${CMAKE_CURRENT_SOURCE_DIR})
add_executable(lizardfs-tests lizardfs-tests.cc)
add_dependencies(lizardfs-tests list_of_test_cases)
target_link_libraries(lizardfs-tests gtest_main)
install(TARGETS lizardfs-tests RUNTIME DESTINATION ${BIN_SUBDIR})

=== src/mount/CMakeLists.txt ===
#  Copyright 2015-2017 Skytechnology sp. z o.o..
#
#  This file is part of LizardFS.
#
#  LizardFS is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, version 3.
#
#  LizardFS is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with LizardFS  If not, see <http://www.gnu.org/licenses/>.

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

collect_sources(MOUNT)

shared_add_library(mount ${MOUNT_SOURCES})
shared_target_link_libraries(mount mfscommon ${ADDITIONAL_LIBS})

create_unittest(mount ${MOUNT_TESTS})
link_unittest(mount mount mfscommon)

if (ENABLE_CLIENT_LIB)
  add_subdirectory(client)
endif()

=== src/protocol/CMakeLists.txt ===
#  Copyright 2015-2017 Skytechnology sp. z o.o..
#
#  This file is part of LizardFS.
#
#  LizardFS is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, version 3.
#
#  LizardFS is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with LizardFS  If not, see <http://www.gnu.org/licenses/>.

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

collect_sources(PROTOCOL)

add_library(lzfsprotocol ${PROTOCOL_SOURCES})

create_unittest(lzfsprotocol ${PROTOCOL_TESTS})
link_unittest(lzfsprotocol mfscommon)
